use strict;
use warnings;

#use Proc::Daemon;

use Test::More;
use Test::Command::Simple;

my $NAME = 'Konclude';
my $CMD  = $ENV{'KONCLUDE'} || 'Konclude';

run_ok $CMD;
like stdout, qr/ Usage: '$NAME'/, 'bare command, stdout';
cmp_ok stderr, 'eq', '', 'bare command, stderr';

run_ok $CMD, qw(-h);
like stdout, qr/ Usage: '$NAME'/, 'version, stdout';
cmp_ok stderr, 'eq', '', 'version, stderr';

run_ok $CMD, qw(owllinkfile -i Tests/test-request.xml -o test-response.xml);
like stdout, qr[Realizing ontology 'http://www.konclude.com/test'], 'test, stdout';
cmp_ok stderr, 'eq', '', 'test, stderr';

run_ok $CMD, qw(owllinkfile -c Configs/default-config.xml -i Tests/test-request.xml -o test-response-cfg.xml);
like stdout, qr[Realizing ontology 'http://www.konclude.com/test'], 'test with config, stdout';
cmp_ok stderr, 'eq', '', 'test with config, stderr';

#FIXME
#my $daemon = Proc::Daemon->new(
#	exec_command => "$Konclude owllinkserver -w 2 -c Configs/default-config.xml -p 8080",
#} );
#sleep 2
#POST < Tests/test-request.xml http://localhost:8080
#pkill Konclude

# TODO: check sanity of output files

# FIXME: hangs forever since v0.6.2-927
#run_ok $CMD, qw(satisfiability -i Tests/galen.owl.xml -x), 'http://ex.test/galen#ExternalIliacVein';
#like stdout, qr[Class 'http://ex.test/galen#ExternalIliacVein' for ontology 'Tests/galen.owl.xml' is satisfiable.], 'satisfiability, stdout';
#cmp_ok stderr, 'eq', '', 'satisfiability, stderr';
#
#run_ok $CMD, qw(classification -w AUTO -i Tests/roberts-family-full-D.owl.xml -o test-response-class.xml);
#like stdout, qr[Finished class classification in \d+ ms for ontology 'http://konclude.com/test/kb'.], 'classification, stdout';
#cmp_ok stderr, 'eq', '', 'classification, stderr';
#
#run_ok $CMD, qw(realization -w AUTO -i Tests/roberts-family-full-D.owl.xml -o test-response-real.xml);
#like stdout, qr[Finished class classification in \d+ ms for ontology 'http://konclude.com/test/kb'.], 'realization, stdout';
#cmp_ok stderr, 'eq', '', 'realization, stderr';

#FIXME
#$Konclude sparqlserver -p 8080 -c Configs/querying-config.xml &
#sleep 2
# FIXME: test file Tests/sparql-load-and-query-test.sparql missing
#$Konclude sparqlfile -i Tests/sparql-load-and-query-test.sparql -o Tests/query-answers.xml -c Configs/querying-config.xml
#pkill Konclude

# TODO: check sanity of output files

done_testing;
